/*
 * MiconoWiiClassicPrint
 * for Wii Classic controller with WiiChunck 
 *
 * 2009/10/04 Micono Utilities (http://micono.cocolog-nifty.com)
 *
 */
// Adopt the serial library
import processing.serial.*;
// Prepare the instance for the serial
Serial myPort;
// Prepare for variable font
PFont font;
// Prepare variables for background image 
PImage  classicControllerPicture;
// Prepare variables for the Wii classic controller
int leftShoulder=0;
int rightShoulder=0;
int leftZ=0;
int rightZ=0;
int leftBtn=0;
int rightBtn=0;
int upBtn=0;
int downBtn=0;
int xBtn=0;
int yBtn=0;
int aBtn=0;
int bBtn=0;
int leftStickX=0;
int leftStickY=0;
int rightStickX=0;
int rightStickY=0;
int selectBtn=0;
int homeBtn=0;
int startBtn=0;

// Location information
int shoulderBtnTop=22;
int centerBtnTop=140;
int StickWH=96;
int leftStickPosLeft=177;
int rightStickPosLeft=324;
int StickPosTop=174;

void setup(){
// Size of screen
  size(600,350);
// Load the font 
  font = loadFont("Osaka-Mono-12.vlw");
// Start using font size: 12
  textFont(font, 12);
// Load the background image
  classicControllerPicture = loadImage("Wii-classic-controller new.png");
// Set the serial port
  myPort=new Serial(this,"COM8",19200);
  myPort.clear();
// to invoke () serialEvent
  myPort.bufferUntil(10);
}

void draw(){
  
  // Background
   image(classicControllerPicture, 0, 0);//background(240);
  // On / off button  
  OnOffFill(leftShoulder,124,shoulderBtnTop);
  OnOffFill(leftZ,233,shoulderBtnTop);
  OnOffFill(rightZ,366,shoulderBtnTop);
  OnOffFill(rightShoulder,475,shoulderBtnTop);

  OnOffFill(leftBtn,100,140);
  OnOffFill(rightBtn,160,140);
  OnOffFill(upBtn,130,110);
  OnOffFill(downBtn,130,170);

  OnOffFill(yBtn,416,143);
  OnOffFill(aBtn,523,143);
  OnOffFill(xBtn,470,105);
  OnOffFill(bBtn,470,180);
  
  OnOffFill(selectBtn,260,centerBtnTop);
  OnOffFill(homeBtn,300,centerBtnTop);
  OnOffFill(startBtn,340,centerBtnTop);

 // Display the value of the stick
  fill(0,0,0); 
  text("X:",leftStickPosLeft+20,300); text(leftStickX,leftStickPosLeft+40,300);
  text("Y:",leftStickPosLeft+20,315); text(leftStickY,leftStickPosLeft+40,315);
  fill(230);//noFill();
  ellipse(leftStickPosLeft+48,StickPosTop+48,96,96);
  fill(255,255,0);
  ellipse(leftStickPosLeft+leftStickX*3,StickPosTop+StickWH-leftStickY*3,32,32);
  
  fill(0,0,0); //black
  text("X:",rightStickPosLeft+20,300); text(rightStickX,rightStickPosLeft+40,300);
  text("Y:",rightStickPosLeft+20,315); text(rightStickY,rightStickPosLeft+40,315);
  fill(230);//noFill();
  ellipse(rightStickPosLeft+48,StickPosTop+48,96,96);
  fill(255,255,0);
  ellipse(rightStickPosLeft+rightStickX*3,StickPosTop+StickWH-rightStickY*3,32,32);
}

// Highlight when the button is pressed
void OnOffFill(int onoff, int l, int t)
{
  if(onoff==1) {
    fill(255,116,142);
    ellipse(l,t,20,20);
  }
}

// Serial communication processing
void serialEvent(Serial p){
// The data has been sent from the Arduino
// Prepare a string variable stringData,   
// "10" until it is read (line feed)
  String stringData=myPort.readStringUntil(10);
  
// When the data string is not empty 
  if(stringData!=null){
// Get rid of the newline character that is included in the data string
    stringData=trim(stringData);
// Prepare an array of integer type data [],     
// Separated by a comma symbol string data based on
// Keep the data to an integer array to [] 
    int data[]=int(split(stringData,','));
 // Data in the data array [] If the nineteen   
    if(data.length==19){
      leftShoulder=data[0];
      rightShoulder=data[1];
      leftZ=data[2];
      rightZ=data[3];
      leftBtn=data[4];
      rightBtn=data[5];
      upBtn=data[6];
      downBtn=data[7];
      xBtn=data[8];
      yBtn=data[9];
      aBtn=data[10];
      bBtn=data[11];
      leftStickX=data[12];
      leftStickY=data[13];
      rightStickX=data[14];
      rightStickY=data[15];
      selectBtn=data[16];
      homeBtn=data[17];
      startBtn=data[18];
    }
  }
}
